<template>
    <main-master-page>
        <div class="text-main-title">Analytics Pixel Player</div>
        <div v-show="!loading"><date-range-picker :class="$style['block-space']" /></div>
        <kpi-block v-show="!loading" :items="kpiItemsTotal" :class="$style['block-space']" />
        <chart-component
            v-show="!loading"
            title="Impressions by hours"
            :chart-data="hourlyDataDaily"
            :class="$style['block-space']"
        />
        <chart-component
            v-show="!loading"
            title="Impressions by days"
            :chart-data="graphDataDaily"
            :class="$style['block-space']"
        />

        <tables-section
            v-show="!loading"
            :items="impressionsByDays"
            :columns="impressionsByDaysColumns"
            :class="$style['block-space']"
        />
    </main-master-page>
</template>

<script>
import MainMasterPage from '@/masterpages/MainMasterPage.vue'
import DateRangePicker from '@/components/DateRangePicker.vue'
import KpiBlock from '@/components/KpiBlock'
import ChartComponent from '@/components/ChartComponent.vue'
import TablesSection from '@/components/TablesSection.vue'
import { formatBigNumbers } from '@/utils/utils'
import { useDailyStore } from '@/store/modules/daily'
import { useHourlyStore } from '@/store/modules/hourly'
import { useTotalStore } from '@/store/modules/total'
import { useGeneralStore } from '@/store/modules/general'
import { mapState } from 'pinia'
import { monthsShort } from '@/constants/generalConstants'
export default {
    name: 'PixelDashboard',

    components: {
        DateRangePicker,
        KpiBlock,
        ChartComponent,
        MainMasterPage,
        TablesSection,
    },

    data() {
        return {
            date: null,
            impressionsByHoursColumns: [
                {
                    field: 'hour',
                    label: 'Hour',
                    width: '40',
                    numeric: true,
                },
                {
                    field: 'impressions',
                    label: 'Impressions',
                    formatValue: formatBigNumbers,
                },
            ],
            impressionsByDaysColumns: [
                {
                    field: 'day',
                    label: 'Day',
                    numeric: true,
                },
                {
                    field: 'impressions',
                    label: 'Impressions',
                    numeric: true,
                    formatValue: formatBigNumbers,
                },
            ],
        }
    },

    computed: {
        ...mapState(useDailyStore, ['dailyList']),
        ...mapState(useHourlyStore, ['hourlyList']),
        ...mapState(useTotalStore, ['totalList']),
        ...mapState(useGeneralStore, ['loading']),
        kpiItemsTotal() {
            return this.totalList?.impressions
                ? [
                      {
                          label: 'Impressions',
                          number: formatBigNumbers(this.totalList.impressions),
                          comment: '',
                          bgColor: '#ffdcdd',
                          color: '#f01527',
                      },
                  ]
                : []
        },
        impressionsByDays() {
            return this.dailyList.map((day) => ({
                day: this.getCorrectDate(day.date),
                impressions: day.impressions,
            }))
        },
        hourlyDataDaily() {
            const labels = []
            const data = []
            this.hourlyList.forEach((hour) => {
                labels.push(this.getShortDayDate(hour.datehour))
                data.push(hour.impressions)
            })
            return {
                labels,
                datasets: [
                    {
                        label: 'Impression per hour',
                        data,
                        tension: 0.3,
                        pointRadius: 0,
                        borderColor: '#00aeff',
                        backgroundColor: '#c319ee',
                        pointHoverBorderColor: '#00aeff',
                    },
                ],
            }
        },
        graphDataDaily() {
            const labels = []
            const data = []
            this.dailyList.forEach((day) => {
                labels.push(this.getShortDate(day.date))
                data.push(day.impressions)
            })
            return {
                labels,
                datasets: [
                    {
                        label: 'Impression per day',
                        // backgroundColor: '#f87979',
                        data,
                        tension: 0.3,
                        pointRadius: 0,
                        borderColor: '#f01527',
                        backgroundColor: '#c319ee',
                    },
                ],
            }
        },
    },

    methods: {
        getCorrectDate(date) {
            const arr = date.split('-')
            return `${arr[2]}/${arr[1]}/${arr[0]}`
        },
        getShortDate(date) {
            const arr = date.split('-')
            return `${arr[2]} ${monthsShort[parseInt(arr[1]) - 1]}`
        },
        getShortDayDate(date) {
            const arr = date.split('T')
            const dateArr = arr[0].split('-')
            const hour = arr[1].split('Z')[0]
            return `${hour}:00 ${monthsShort[parseInt(dateArr[1]) - 1]} ${dateArr[2]}`
        },
    },
}
</script>

<style lang="scss" module>
@import '@/assets/styles/variables';
.block-space {
    margin-top: 64px;
}
</style>
